#include <stdio.h>
#include <stdlib.h>

#include "ClassesXML.h"




Classe* Remplir_Classes(FILE* Classes_log, const char *filename) /* Remplit le tableau de classes  partir du fichier XML */
{

    fprintf(Classes_log,"I) Chargement du fichier XML - Definition des noeuds\n");

    node_t *rootXML, *ClassesXML;
    unsigned int i=0, nb_classes=0;

    rootXML = roxml_load_doc(filename);            /* Ouvre le doc XML et cr le noeud de base */
    ClassesXML = roxml_get_chld(rootXML, NULL, 0);    /* Descend d'un niveau dans l'arborescence */
    nb_classes = roxml_get_chld_nb(ClassesXML);    /* Rcupre le nombre de classes entres dans le fichier XML */

    fprintf(Classes_log,"Le fichier contient %d classes\n", nb_classes);

/*---------------------------------------------------------------------------------------------------*/

    fprintf(Classes_log,"II) Chargement des classes\n");

    Classe* ListeClasse = NULL;
    ListeClasse = malloc(nb_classes * sizeof(Classe));     /* Allocation de la mmoire ncssaire et test*/
    if (ListeClasse == NULL)
    {
        fprintf(Classes_log,"Allocation impossible \n");
        exit(EXIT_FAILURE);
    }
    fprintf(Classes_log,"1) Memoire allouee avec succes \n");
    fprintf(Classes_log,"La memoire allouee fait %d octets\n",nb_classes * sizeof(Classe));

/*--------------------------------------------------------------------------------------------------*/

    for(i=0; i<nb_classes; i++)   /* Boucle de remplissage des classes */
    {
    fprintf(Classes_log,"\nChargement de la classe numero %d\n", i+1);

    Classe Classe_en_cours;

    node_t *ClasseXML;
    char *id_text, *name_text, *PV_text, *PM_text, *MV_text, *DESC_text;
    int PV_int, PMM_int, PD_int;

    ClasseXML = roxml_get_chld(ClassesXML, NULL, i);

    node_t *Skills, *ID, *NAME, *PV, *PM, *MV, *DESC;

    ID = roxml_get_attr(ClasseXML, "id", 0);
    NAME = roxml_get_attr(ClasseXML, "name", 0);
    PV = roxml_get_attr(ClasseXML, "PV", 0);
    PM = roxml_get_attr(ClasseXML, "PM", 0);
    MV = roxml_get_attr(ClasseXML, "MV", 0);
    DESC = roxml_get_attr(ClasseXML, "Desc", 0);

    id_text = roxml_get_content(ID, NULL, 0, NULL);
    name_text = roxml_get_content(NAME, NULL, 0, NULL);
    PV_text = roxml_get_content(PV, NULL, 0, NULL);
    PM_text = roxml_get_content(PM, NULL, 0, NULL);
    MV_text = roxml_get_content(MV, NULL, 0, NULL);
    DESC_text = roxml_get_content(DESC, NULL, 0, NULL);

    fprintf(Classes_log,"Id : %s\n", id_text);
    fprintf(Classes_log,"Nom : %s\n", name_text);
    fprintf(Classes_log,"PV : %s\n", PV_text);
    fprintf(Classes_log,"PM : %s\n", PM_text);
    fprintf(Classes_log,"MV : %s\n", MV_text);
    fprintf(Classes_log,"DESC : %s\n", DESC_text);

    /* Convertion des caractristiques lues vers les types de la struct Classe */
    PV_int = atoi(PV_text);
    PMM_int = atoi(PM_text);
    PD_int = atoi(MV_text);

/*----------------------------------------------------------------------------------------------------*/

    /* Remplissage des caractristiques de la classe en cours */
    Classe_en_cours.PV_max=PV_int;
    Classe_en_cours.mana_max=PMM_int;
    Classe_en_cours.points_deplacement_max=PD_int;
    strcpy(Classe_en_cours.nom, id_text);

    fprintf(Classes_log,"Insertion de la classe %d dans le tableau\n", i+1);

    /* Ajout de la classe remplie au tableau */
    ListeClasse[i] = Classe_en_cours;
    }

roxml_free_node(rootXML);
roxml_free_node(ClassesXML);


return ListeClasse;
}

